/*
	Transposition AS3 d'un code de Jean-Louis Gaujal
*/
package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;

	public class Colliner extends Sprite
	{
		private var nombre:Number;
		public function Colliner()
		{
			//sécurité pour être sûr que le stage a été ajouter sur le stag
			addEventListener(Event.ADDED_TO_STAGE,added_handler);
		}
		private function added_handler(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
		}
		private function down_handler(e:MouseEvent):void
		{
			if( nombre != 0 ){
				for(var i:Number=0;i<nombre;i++){
					var col:DisplayObject = getChildByName("collin"+i);
					removeChild(col);
				}
			}
			nombre = 0;
			stage.addEventListener(MouseEvent.MOUSE_MOVE,move_handler);
		}
		private function up_handler(e:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,move_handler);
		}
		private function move_handler(e:MouseEvent):void
		{
			var collin:Collin = new Collin();
			collin.name = "collin" + nombre;
			collin.x = mouseX;
			collin.y = mouseY;
			collin.long =0;
			collin.angle = 120;
			var couleur:uint =Math.random()*0xffcccc;
			collin.graphics.lineStyle(20/**/,couleur,5);
			collin.addEventListener(Event.ENTER_FRAME,enter_handler);
			addChild(collin);
			nombre++;
		}
		private function enter_handler(e:Event):void
		{
			e.currentTarget.angle +=.0;
			//calcul pour l'onde
			e.currentTarget.posx = 10/**//**/ * (Math.cos(0.003 *e.currentTarget.long*e.currentTarget.angle - (e.currentTarget.y/40) - Math.sin(e.currentTarget.long/5)));
			if(e.currentTarget.long > stage.stageWidth){
				e.currentTarget.graphics.lineTo(e.currentTarget.posx,stage.stageWidth)//);
				e.currentTarget.removeEventListener(Event.ENTER_FRAME,enter_handler);
			}else{
				e.currentTarget.graphics.lineTo(e.currentTarget.posx,e.currentTarget.long);
			}
			e.currentTarget.long+=2;
		}
	}
}
import flash.display.Sprite;
class Collin extends Sprite{
	public var long:Number;
	public var angle:Number;
	public var posx:Number;
	function Collin(){
	}
}